clear all
nline=1;
ntrans=2;
ngen=2;
nb=4;
load gen.dat;
load nt_line.dat;
load nt_trans.dat;
Ypos=sparse(zeros(nb,nb));  %Positive-sequence Ybus matrix
xddd=gen(:,4);
xqdd=gen(:,9);

%-------------Building of pos-sequence Ybus from line impedances------------------
for i=1:nline
   incr=1/(nt_line(i,4)+j*nt_line(i,5));
   Ypos((nt_line(i,2)),(nt_line(i,3)))=Ypos((nt_line(i,2)),(nt_line(i,3)))-incr;
   Ypos((nt_line(i,3)),(nt_line(i,2)))=Ypos((nt_line(i,3)),(nt_line(i,2)))-incr;
   Ypos((nt_line(i,2)),(nt_line(i,2)))=Ypos((nt_line(i,2)),(nt_line(i,2)))+incr+j*nt_line(i,9)/2;
   Ypos((nt_line(i,3)),(nt_line(i,3)))=Ypos((nt_line(i,3)),(nt_line(i,3)))+incr+j*nt_line(i,9)/2;
end
%-------------Accounting transformers impedances---------------
for i=1:ntrans
   incr=1/(nt_trans(i,4)+j*nt_trans(i,5));  
   incr1=incr/nt_trans(i,7);
   incr2=(1-nt_trans(i,7))*incr/(nt_trans(i,7)*nt_trans(i,7));
   incr3=(nt_trans(i,7)-1)*incr/nt_trans(i,7);
   Ypos((nt_trans(i,2)),(nt_trans(i,3)))=Ypos((nt_trans(i,2)),(nt_trans(i,3)))-incr1;
   Ypos((nt_trans(i,3)),(nt_trans(i,2)))=Ypos((nt_trans(i,3)),(nt_trans(i,2)))-incr1;
   Ypos((nt_trans(i,2)),(nt_trans(i,2)))=Ypos((nt_trans(i,2)),(nt_trans(i,2)))+incr1+incr2;
   Ypos((nt_trans(i,3)),(nt_trans(i,3)))=Ypos((nt_trans(i,3)),(nt_trans(i,3)))+incr1+incr3;   
end

%-------------Accounting generator impedances into pos-sequence Ybus---------------
for i=1:ngen
   incr=1/(j*xddd(i));
   Ypos((gen(i,1)),(gen(i,1)))=Ypos((gen(i,1)),(gen(i,1)))+incr;
end
%----------------------------------------------------------------
Yneg=Ypos;
for i=1:ngen   
   Yneg((gen(i,1)),(gen(i,1)))=Yneg((gen(i,1)),(gen(i,1)))-(1/(j*xddd(i)))+(1/(j*0.5*(xddd(i)+xqdd(i))));
end

Zpos=full(inv(Ypos))
Zneg=full(inv(Yneg))





