clear all
nline=1;
ntrans=2;
ngen=2;
nb=4;
load gen.dat;
load nt_line.dat;
load nt_trans.dat;
E=nt_line(:,1);       %Elememt No
nodeP=nt_line(:,2);   %From Node
nodeQ=nt_line(:,3);   %To Node
Xpq=nt_line(:,6);     %Zero Seq Reactance b/w P and Q
ME=nt_line(:,7);      %Mutual Coupling Element
Xm=nt_line(:,8);      %Mutual Reactance Value
j=sqrt(-1); 

MI=zeros(nline,1);    %Mutual Index; if MI=1 mutually coupled;  if MI=0 No coupling
%---------Calculation of Mutual Index--------------
for i=1:nline
   if ME(i)~=0
      MI(i)=1;
      MI(ME(i))=1;
   end
end

if max(MI~=0)
   temp=[E nodeP nodeQ 1./(j*Xpq) MI ME Xm];
   a=1;b=1;
%---------Seperating coupled and non-coupled set of lines ------------
   for f=1:nline
      if temp(f,5)==0
         nm_mat(a,:)=temp(f,:);
         a=a+1;
      else
         m_mat(b,:)=temp(f,:);
         b=b+1;
      end
   end
   clear temp
%----construction of Ybus partial for non-coupled lines-------------
Yzer=sparse(zeros(nb,nb));
if a==1 
   nm_mat=[];
   end
for i=1:size(nm_mat,1)
      Yzer((nm_mat(i,2)),(nm_mat(i,3)))=Yzer((nm_mat(i,2)),(nm_mat(i,3)))-nm_mat(i,4);
      Yzer((nm_mat(i,3)),(nm_mat(i,2)))=Yzer((nm_mat(i,3)),(nm_mat(i,2)))-nm_mat(i,4);
      Yzer((nm_mat(i,2)),(nm_mat(i,2)))=Yzer((nm_mat(i,2)),(nm_mat(i,2)))+nm_mat(i,4);
      Yzer((nm_mat(i,3)),(nm_mat(i,3)))=Yzer((nm_mat(i,3)),(nm_mat(i,3)))+nm_mat(i,4);
   end
   len=length(m_mat(:,1));
   Z_mut=sparse(diag(1./m_mat(:,4)));
   p=m_mat(:,2);
   q=m_mat(:,3);
 %-----------Construction of P matrix---------------
   P_mat=zeros(len,nb);   
   for f=1:len 
      P_mat(f,p(f))=1;
      P_mat(f,q(f))=-1;
      if m_mat(f,6)~=0
         for g=1:len  
%-------------Construction of mutual impedance matrix Zm-------------        
            if m_mat(f,6)==m_mat(g,1)
               Z_mut(f,g)=j*m_mat(f,7);
               Z_mut(g,f)=Z_mut(f,g);                     
               break;
            end              
         end
      end
   end
   
   Y_mut=Z_mut\P_mat; %mutual admittance matrix Ym
   
   for f=1:nb
      for g=1:len
         if P_mat(g,f)~=0
            Yzer(f,:)=Yzer(f,:)+P_mat(g,f)*Y_mut(g,:);
         end
      end
   end

   for i=1:nline
      Yzer((nt_line(i,2)),(nt_line(i,2)))=Yzer((nt_line(i,2)),(nt_line(i,2)))+j*nt_line(i,10)/2;
      Yzer((nt_line(i,3)),(nt_line(i,3)))=Yzer((nt_line(i,3)),(nt_line(i,3)))+j*nt_line(i,10)/2;
   end
   
else
   
   Yzer=sparse(zeros(nb,nb));
   
   for i=1:nline
      incr=1/(j*nt_line(i,6));
      Yzer((nt_line(i,2)),(nt_line(i,3)))=Yzer((nt_line(i,2)),(nt_line(i,3)))-incr;
      Yzer((nt_line(i,3)),(nt_line(i,2)))=Yzer((nt_line(i,3)),(nt_line(i,2)))-incr;
      Yzer((nt_line(i,2)),(nt_line(i,2)))=Yzer((nt_line(i,2)),(nt_line(i,2)))+incr+j*nt_line(i,10)/2;
      Yzer((nt_line(i,3)),(nt_line(i,3)))=Yzer((nt_line(i,3)),(nt_line(i,3)))+incr+j*nt_line(i,10)/2;
   end
end
%-------------Accounting transformers impedances---------------
Ycon=ones(ntrans,3)/(j*1e6);

for i=1:ntrans   
   if nt_trans(i,8)==1
      Ycon(i,3)=1/(j*(nt_trans(i,6)+3*nt_trans(i,9)));
   else 
      if nt_trans(i,8)==2
         Ycon(i,1)=1/(j*(nt_trans(i,6)+3*nt_trans(i,9)));
      else
         Ycon(i,2)=1/(j*(nt_trans(i,6)+3*(nt_trans(i,10)+nt_trans(i,11))));
      end
   end
   
   Yzer((nt_trans(i,2)),(nt_trans(i,3)))=Yzer((nt_trans(i,2)),(nt_trans(i,3)))-Ycon(i,2);
   Yzer((nt_trans(i,3)),(nt_trans(i,2)))=Yzer((nt_trans(i,3)),(nt_trans(i,2)))-Ycon(i,2);
   Yzer((nt_trans(i,2)),(nt_trans(i,2)))=Yzer((nt_trans(i,2)),(nt_trans(i,2)))+Ycon(i,2)+Ycon(i,1);
   Yzer((nt_trans(i,3)),(nt_trans(i,3)))=Yzer((nt_trans(i,3)),(nt_trans(i,3)))+Ycon(i,2)+Ycon(i,3);
end
%-------------Accounting generator impedances into zero-sequence Ybus----------
for i=1:ngen
   incr=1/(3*j*gen(i,16)+j*gen(i,15));
   Yzer((gen(i,1)),(gen(i,1)))=Yzer((gen(i,1)),(gen(i,1)))+incr;
end
%---------------------------------------------------------------
Zzero=full(inv(Yzer))
   




    
      
