e_fbus=zeros(nb,1);
e_fbus(fbus)=1;
Zp_fbus=Ypos\e_fbus; %fbus (m th) column of positive sequence impedance matrix
Zp_th=Zp_fbus(fbus); %positive sequence  Thevenin impedance at bus m
Zn_fbus=Yneg\e_fbus; %fbus (m th) column of negative sequence impedance matrix   
Zn_th=Zn_fbus(fbus); %negative sequence Thevenin impedance at bus m 
Zz_fbus=Yzer\e_fbus; %fbus (m th) column of Zero sequence impedance matrix         
Zz_th=Zz_fbus(fbus); %Zero sequence Thevenin impedance at bus m
Zp_fbusn=Zp_fbus;
Zfeq=1;              %Default short-circuit eq impedance
Zoc_eq=1;            %Default open-conductor eq impedance
Z1=1;                %Default positive-sequence impedance of the line
if Tfault~=1000      
%--------------- Short Circuit Fault Calculations -------------------
   switch(ftype)
   case 1
      Zfeq=Zp_th + Zn_th + Zz_th + 3*Z_f;  %LG fault
   case 2
      Zfeq=Zp_th + Zn_th + Z_f;            %LL fault
   case 3
      Zfeq=Zp_th +(Zn_th*(Zz_th + 3*Z_f)/(Zn_th + Zz_th + 3*Z_f)); %LLG fault
   case 4
      Zfeq=Zp_th + Z_f;                    %LLLG fault
   end

%--------------- Open Conductor Fault Calaulations --------------------   
   if (ftype >4 | ftype1 >4)
      e_fbusn=zeros(nb,1);
      e_fbusn(fbusn)=1;
      Zp_fbusn=Ypos\e_fbusn;   %fbusn (n th) column of positive sequence impedance matrix
      Zp_thn=Zp_fbusn(fbusn);  %positive sequence  Thevenin impedance at bus n   
      Zn_fbusn=Yneg\e_fbusn;   %fbusn (n th) column of negative sequence impedance matrix 
      Zn_thn=Zn_fbusn(fbusn);  %negative sequence Thevenin impedance at bus n 
      Zz_fbusn=Yzer\e_fbusn;   %fbusn (n th) column of Zero sequence impedance matrix      
      Zz_thn=Zz_fbusn(fbusn);  %Zero sequence Thevenin impedance at bus n
      
      Z1=nt_line(Line1,4)+j*nt_line(Line1,5); %Line positive sequence impedance
      Z2=Z1;                                  %Line negative sequence impedance
      Z0=j*nt_line(Line1,6);                  %Line Zero sequence impedance
      
      Zp_mn=-(Z1*Z1)/(Zp_th+Zp_thn-2*Zp_fbusn(fbus)-Z1); %eq positive seq imp 
      Zn_mn=-(Z2*Z2)/(Zn_th+Zn_thn-2*Zn_fbusn(fbus)-Z2); %eq negative seq imp
      Zz_mn=-(Z0*Z0)/(Zz_th+Zz_thn-2*Zz_fbusn(fbus)-Z0); %eq zero  seq imp
      
      if (ftype==5 | ftype==1)
         Zoc_eq=(Zp_mn*Zn_mn*Zz_mn)/(Zp_mn*Zn_mn+Zn_mn*Zz_mn+Zp_mn*Zz_mn); %1 conductor OC
      else
         Zoc_eq=Zp_mn*(Zn_mn+Zz_mn)/(Zp_mn+Zn_mn+Zz_mn);                   %2 conductor OC
      end
   end
end


   