%%%%%%%%%%%%%%%%%%%%%%%%% SYSTEM DATA %%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all

load busno.dat;   %Loads System details- no.of Lines, Buses, Transformers, etc..
load nt_line.dat; %Loads Transmission line
load nt_trans.dat;%Transformer data
load gen.dat;     %Loads Generators data
load ld.dat;      %Loads Load data

if (busno(9)~=0)
load shunt.dat;   %Loads Shunt data
end

nb=busno(3);      %Number of buses
nline=busno(4);   %Number of lines
ntrans=busno(5);  %Number of transformers
ngen=size(gen,1); %Number of generators
nshunt=busno(9);  %Number of shunts
nload=size(ld,1); %Number of loads
wB=busno(11)*2*pi;

%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% Read in the load flow data and calculate initial conditions
% call initcond.m
initcond
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%~~~~~~~~~~~~~~~~~~~~~~~

yform    %positive and negative sequence Ybus matrix
yzero    %zero sequence Ybus matrix
fault    %calculation of fault parameters

