
Ypos=sparse(zeros(nb,nb));  %Positive-sequence Ybus matrix

%-------------Building of pos-sequence Ybus from line impedances------------------
for i=1:nline
   incr=1/(nt_line(i,4)+j*nt_line(i,5));
   Ypos((nt_line(i,2)),(nt_line(i,3)))=Ypos((nt_line(i,2)),(nt_line(i,3)))-incr;
   Ypos((nt_line(i,3)),(nt_line(i,2)))=Ypos((nt_line(i,3)),(nt_line(i,2)))-incr;
   Ypos((nt_line(i,2)),(nt_line(i,2)))=Ypos((nt_line(i,2)),(nt_line(i,2)))+incr+j*nt_line(i,9)/2;
   Ypos((nt_line(i,3)),(nt_line(i,3)))=Ypos((nt_line(i,3)),(nt_line(i,3)))+incr+j*nt_line(i,9)/2;
end
%-------------Accounting transformers impedances---------------
for i=1:ntrans
   incr=1/(nt_trans(i,4)+j*nt_trans(i,5));  
   incr1=incr/nt_trans(i,7);
   incr2=(1-nt_trans(i,7))*incr/(nt_trans(i,7)*nt_trans(i,7));
   incr3=(nt_trans(i,7)-1)*incr/nt_trans(i,7);
   Ypos((nt_trans(i,2)),(nt_trans(i,3)))=Ypos((nt_trans(i,2)),(nt_trans(i,3)))-incr1;
   Ypos((nt_trans(i,3)),(nt_trans(i,2)))=Ypos((nt_trans(i,3)),(nt_trans(i,2)))-incr1;
   Ypos((nt_trans(i,2)),(nt_trans(i,2)))=Ypos((nt_trans(i,2)),(nt_trans(i,2)))+incr1+incr2;
   Ypos((nt_trans(i,3)),(nt_trans(i,3)))=Ypos((nt_trans(i,3)),(nt_trans(i,3)))+incr1+incr3;   
end
%-------------Accounting shunts into pos-sequence Ybus---------------
for i=1:nshunt
   incr=shunt(i,2)+j*shunt(i,3);
   Ypos((shunt(i,1)),(shunt(i,1)))=Ypos((shunt(i,1)),(shunt(i,1)))+incr;
end

kcir1=QL0./VL0.^2;
kci1=PL0./VL0.^2;
%-------------Accounting loads into pos-sequence Ybus---------------
for i=1:nload
   incr=kci1(i)-j*kcir1(i); 
   Ypos((ld(i,1)),(ld(i,1)))=Ypos((ld(i,1)),(ld(i,1)))+incr;
end
%-------------Accounting generator impedances into pos-sequence Ybus---------------
for i=1:ngen
   incr=1/(j*xddd(i));
   Ypos((gen(i,1)),(gen(i,1)))=Ypos((gen(i,1)),(gen(i,1)))+incr;
end
%----------------------------------------------------------------
clc
fbus=1;   %Default fault bus number for any type of fault
fbusn=1;  %Default fault bus number for open-conductor fault
y=1; n=2; yn1=0; ftype1=0;
Line=[]; Trans=[];
Tfault=1000; Tclear=0; Topen=1000; Tclose=1000;
disp('Choose the type of fault from the menu:') 
ftype=input('  1. LG\n  2. LL  \n  3. LLG\n  4. LLL\n  5. One conductor OC \n  6. Two conductor OC\n  7. Sample run without any fault\n\nEnter the type of fault:');
fprintf('\n');

if ftype < 7
   Tfault=input('Fault initiation time (seconds), Tfault: '); 
   Tclear=input('Enter the fault duration time (seconds), Tclear: ');
   Tclose=Tfault+Tclear;        
   if ftype>4
      Line1=input('Open conductor fault on line number: ');
      fbus=nt_line(Line1,2);
      fbusn=nt_line(Line1,3);
      fprintf('Clear the fault by  tripping line %d ? y / n : ',Line1);
      yn1=input('');
      if yn1==1
         Line=Line1;
      end
      fprintf('\n');
   else
      Z_f=input('Enter the fault impedance Zf= ');
      fbus=input('Enter the fault bus number: ');
      fprintf('\n');
      if ftype<4 % for LG, LL, LLG faults-----------         
         yn2=input('Open the respective conductor(s)?  y / n : ');  
         fprintf('\n');
         if yn2==1
            ftype1=5;
            Line1=input('Enter the line number= ');
            dt1=input('Enter time duration dTopen w.r.t Tfault, such that dTopen<Tclear: ');
            Topen=Tfault+dt1;
            fbus=nt_line(Line1,2);
            fbusn=nt_line(Line1,3);
            fprintf('\n');
            fprintf('Clear the fault by  tripping line %d ? y / n : ',Line1);
            yn1=input('');            
            if yn1==1
               Line=Line1;
               fprintf('\n');               
            end            
         else                                  
            yn1=input('Clear the fault by Line(s)/Transformer(s) tripping?  y / n : ');            
         end                
      else  % for LLL fault--------------                    
         yn1=input('Clear the fault by Line(s)/Transformer(s) tripping?  y / n : ');
      end       
      if (yn1==1 & ftype1~=5)
         fprintf('\n');
         disp('Press ENTER to skip line/transformer tripping')
         Line=input('Enter the Line number(s) to be tripped [ ]= '); 
         Trans=input('Enter the Transformer(s) to be tripped, [ ]= ');
         fprintf('\n');                  
      end      
   end
end

Ypfpos=Ypos; %post fault positive-sequence Ybus

%For line tripping  
if ~isempty(Line) 
   for trip = Line
      incr=1/(nt_line(trip,4)+j*nt_line(trip,5));
      Ypfpos(nt_line(trip,2),nt_line(trip,3))=Ypfpos(nt_line(trip,2),nt_line(trip,3))+incr;
      Ypfpos(nt_line(trip,3),nt_line(trip,2))=Ypfpos(nt_line(trip,3),nt_line(trip,2))+incr; 
      Ypfpos(nt_line(trip,2),nt_line(trip,2))=Ypfpos(nt_line(trip,2),nt_line(trip,2))-incr-j*nt_line(trip,9)/2;
      Ypfpos(nt_line(trip,3),nt_line(trip,3))=Ypfpos(nt_line(trip,3),nt_line(trip,3))-incr-j*nt_line(trip,9)/2;
       
   end
end   

% For transformer tripping
if ~isempty(Trans) 
   for trip = Trans 
      incr=1/(nt_trans(trip,4)+j*nt_trans(trip,5));  
      incr1=incr/nt_trans(trip,7);
      incr2=(1-nt_trans(trip,7))*incr/(nt_trans(trip,7)*nt_trans(trip,7));
      incr3=(nt_trans(trip,7)-1)*incr/nt_trans(trip,7);
      Ypfpos((nt_trans(trip,2)),(nt_trans(trip,3)))=Ypfpos((nt_trans(trip,2)),(nt_trans(trip,3)))+incr1;
      Ypfpos((nt_trans(trip,3)),(nt_trans(trip,2)))=Ypfpos((nt_trans(trip,3)),(nt_trans(trip,2)))+incr1;
      Ypfpos((nt_trans(trip,2)),(nt_trans(trip,2)))=Ypfpos((nt_trans(trip,2)),(nt_trans(trip,2)))-incr1-incr2;
      Ypfpos((nt_trans(trip,3)),(nt_trans(trip,3)))=Ypfpos((nt_trans(trip,3)),(nt_trans(trip,3)))-incr1-incr3;   
   end
end

if ((~isempty(Line) | ~isempty(Trans))) 
   if (ftype1==5 | ftype>4)
      yn4=input('Reclose the tripped Line ?  y / n : ');
   else
      yn4=input('Reclose the tripped Line(s)/Transformer(s)?  y / n : ');
   end   
   if yn4==1    
      dt2=input('Enter time duration dTclose such that, Tclose = Tfault + Tclear + dTclose: ');
      Tclose=Tfault + Tclear + dt2;
      Yclpos=Ypos;
   else 
      Yclpos=Ypfpos;  
   end
else
   Yclpos=Ypos;
end


%--------Building of negative-sequence Ybus-----------------------------

Yneg=Ypos;
for i=1:ngen   
   Yneg((gen(i,1)),(gen(i,1)))=Yneg((gen(i,1)),(gen(i,1)))-(1/(j*xddd(i)))+(1/(j*0.5*(xddd(i)+xqdd(i))));
end

%Frequency Dependancy of Load parameters:
kpf=1.5;
kqf=2;
%Now back to the main program



